package cviceni03;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;

public class Fronta implements Iterable{
    List prvky = new LinkedList();

//    public Fronta(Object[] o){
//        for(int i=0; i<o.length; i++)
//            prvky.add(o[i]);
//    }

    public Fronta(Object... o){
        for(Object x : o)
            prvky.add(x);
    }

    public void zarad( Object o ) {
        prvky.add( o );
    }

    public Object dalsi() {
        Object ret = prvky.get(0);
        prvky.remove(0);
        return ret;
    }
    
    public Iterator iterator() {
        return new Iterator() {
            int poradi = 0;
            
            public boolean hasNext() { 
                return (poradi < prvky.size()); 
            }
            public Object next() { 
                return prvky.get( poradi++ ); 
            }
            public void remove() {
//                System.out.println("Nazdar");
//                Object o = prvky.remove(0);
//                System.out.println("Odebran: " + o);
                throw new UnsupportedOperationException();
            }
        };
    }
    
    public static void test() {
        Random rnd = new Random();
//        Fronta fronta = new Fronta();
        Fronta fronta = new Fronta(1, 3, 5, 7, 9);
        
        System.out.println("Pridavame:");
        for( int i=0;   i < 5;   i++ ) {
            int cislo = new Integer(rnd.nextInt(100));
            fronta.zarad( cislo );
            System.out.println("Pridano: " + cislo);
            System.out.print  ("   Stav:");
            //Pouziti cyklu for(:) na instance tridy Fronta
            for( Object fo : fronta )
                System.out.print( " " + fo );
            System.out.println("");
        }
        System.out.println("\nOdstranujeme:");
//        Iterator it = fronta.iterator();
//        it.remove();
        for( int i=0;   i < 5;   i++ ) {
            Object objekt = fronta.dalsi();
            System.out.println("Obslouzeno: " + objekt);
            System.out.print  ("      Stav:");
            //Pouziti cyklu for(:) na instance tridy Fronta
            for( Object fo : fronta )
                System.out.print( " " + fo );
            System.out.println("");
        }
    }
        
    public static void main(String[] args) {
        test();
    }
}
