package cviceni03;

import java.util.LinkedList;
import java.util.List;

public class FrontaTextuStara 
{
    List nazvy = new LinkedList();

    public void zarad( String nazev ) {
        nazvy.add( nazev );
    }

    public void zarad_1( Object objekt ) {
        //Umozni zaradit do seznamu jakykoliv objekt
        nazvy.add( objekt );
    }
    
    public boolean isDalsi() {
        return (nazvy.size() > 0);
    }

    public String dalsi() {
        //Pri vyjimani prvku z kotejneru je treba obdrzeny odkaz pretypovat
        String ret = (String)nazvy.get(0);
        nazvy.remove(0);
        return ret;
    }

//===== TESTY =================================================================

    public static void test() {
        FrontaTextuStara fts = new FrontaTextuStara();
        for( String s : new String[] { "raz", "dva", "tri" } )
            fts.zarad( s );
        fts.zarad_1( fts );
        
        System.out.println("Texty ve fronte: ");
        while( fts.isDalsi() ) {
            System.out.println("   " + fts.dalsi() );
        }
    }
    
    
    /***************************************************************************
     *
     */
    public static void main( String... args )
    {
        test();
    }
}
